--- old/usr/src/cmd/file/Makefile	2019-03-01 17:09:59.542634604 +0000
+++ new/usr/src/cmd/file/Makefile	2019-03-01 17:09:59.557517513 +0000
@@ -44,9 +44,6 @@
 CERRWARN += -_gcc=-Wno-uninitialized
 CERRWARN += -_gcc=-Wno-type-limits
 
-# not linted
-SMATCH=off
-
 POFILE= file_all.po
 POFILES= $(SRCS:%.c=%.po)
 
--- old/usr/src/cmd/file/elf_read.c	2019-03-01 17:09:59.921374823 +0000
+++ new/usr/src/cmd/file/elf_read.c	2019-03-01 17:09:59.935857442 +0000
@@ -509,7 +509,7 @@
 			Elf_Dyn dyn;
 			FILE_ELF_SIZE_T dsize;
 			FILE_ELF_OFF_T doff;
-			int dynn;
+			uint64_t dynn;
 
 			doff = shdr->sh_offset;
 			dsize = sizeof (Elf_Dyn);
--- old/usr/src/cmd/file/file.c	2019-03-01 17:10:00.359748664 +0000
+++ new/usr/src/cmd/file/file.c	2019-03-01 17:10:00.374937521 +0000
@@ -853,7 +853,8 @@
 	for (i = 0; i < Max; /* null */)
 		if (fbuf[i] & 0200) {
 			IS_ascii = 0;
-			if (fbuf[0] == '\100' && fbuf[1] == '\357') {
+			if ((fbuf[0] == '\100') &&
+			    ((uchar_t)fbuf[1] == (uchar_t)'\357')) {
 				(void) printf(gettext("troff output\n"));
 				return;
 			}
--- old/usr/src/cmd/file/magicutils.c	2019-03-01 17:10:00.880121954 +0000
+++ new/usr/src/cmd/file/magicutils.c	2019-03-01 17:10:00.896519017 +0000
@@ -29,8 +29,6 @@
 /*	Copyright (c) 1987, 1988 Microsoft Corporation	*/
 /*	  All Rights Reserved	*/
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
@@ -243,7 +241,7 @@
 
 	/* mtab may have been allocated on a previous f_mkmtab call */
 	if (mtab == (Entry *)NULL) {
-		if ((mtab = calloc(sizeof (Entry), NENT)) == NULL) {
+		if ((mtab = calloc(NENT, sizeof (Entry))) == NULL) {
 			int err = errno;
 			(void) fprintf(stderr, gettext("%s: malloc "
 			    "failed: %s\n"), File, strerror(err));
--- old/usr/src/cmd/sgs/libld/common/args.c	2019-03-01 17:10:01.388757738 +0000
+++ new/usr/src/cmd/sgs/libld/common/args.c	2019-03-01 17:10:01.404787985 +0000
@@ -1548,6 +1548,11 @@
 			    MSG_ARG_ASSDEFLIB_SIZE) == 0) {
 				if (assdeflib_parse(ofl, optarg) != TRUE)
 					return (S_ERROR);
+
+			/*
+			 * Process new-style output type specification, which
+			 * we'll use in pass 2 and throughout.
+			 */
 			} else if (strncmp(optarg, MSG_ORIG(MSG_ARG_TYPE),
 			    MSG_ARG_TYPE_SIZE) == 0) {
 				char *p = optarg + MSG_ARG_TYPE_SIZE;
--- old/usr/src/cmd/sgs/libld/common/files.c	2019-03-01 17:10:01.918823244 +0000
+++ new/usr/src/cmd/sgs/libld/common/files.c	2019-03-01 17:10:01.929869227 +0000
@@ -3197,12 +3197,13 @@
 			return (0);
 		}
 
-		if (_gelf_getdynval(elf, DT_SUNW_KMOD) == 1) {
+		if (_gelf_getdynval(elf, DT_SUNW_KMOD) > 0) {
 			_rej.rej_name = name;
 			DBG_CALL(Dbg_file_rejected(ofl->ofl_lml, &_rej,
 			    ld_targ.t_m.m_mach));
 			_rej.rej_type = SGS_REJ_KMOD;
 			_rej.rej_str = elf_errmsg(-1);
+			_rej.rej_name = name;
 
 			if (rej->rej_type == 0) {
 				*rej = _rej;
--- old/usr/src/cmd/sgs/libld/common/sections.c	2019-03-01 17:10:02.538502441 +0000
+++ new/usr/src/cmd/sgs/libld/common/sections.c	2019-03-01 17:10:02.556675453 +0000
@@ -1274,6 +1274,7 @@
 			cnt++;
 	}
 
+	/* DT_SUNW_KMOD */
 	if (ofl->ofl_flags & FLG_OF_KMOD)
 		cnt++;
 
--- old/usr/src/cmd/sgs/libld/common/syms.c	2019-03-01 17:10:03.176015009 +0000
+++ new/usr/src/cmd/sgs/libld/common/syms.c	2019-03-01 17:10:03.193401555 +0000
@@ -961,7 +961,6 @@
 {
 	Sym_desc	*sdp;
 	Sg_desc		*sgp;
-	Aliste		idx1;
 
 	DBG_CALL(Dbg_syms_spec_title(ofl->ofl_lml));
 
@@ -975,6 +974,8 @@
 	 */
 	if (!(ofl->ofl_flags & FLG_OF_RELOBJ) ||
 	    (ofl->ofl_flags & FLG_OF_KMOD)) {
+		Aliste		idx1;
+
 		for (APLIST_TRAVERSE(ofl->ofl_segs, idx1, sgp)) {
 			Os_desc *osp;
 			Aliste idx2;
